> ## Documentation Index
> Fetch the complete documentation index at: https://docs.coingecko.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Coin Historical Chart Data by Token Address

> This endpoint allows you to **get the historical chart data including time in UNIX, price, market cap and 24hr volume based on asset platform and particular token contract address**

<Tip>
  ### Tips

  * You may obtain the asset platform and contract address via several ways:
    * Refer to respective coin page and find 'contract address'.
    * Refer to [`/coins/list`](/v3.0.1/reference/coins-list) endpoint (`include_platform=true`).
</Tip>

<Note>
  ### Note

  * You may leave the interval params empty for automatic granularity:
    * 1 day from current time = **5-minutely** data
    * 2 - 90 days from current time = **hourly** data
    * above 90 days from current time = **daily** data (00:00 UTC)
  * Cache / Update Frequency:
    * Every 5 minutes for all the API plans.
    * The last completed UTC day (00:00) is available 35 minutes after midnight on the next UTC day (00:35). The cache will always expire at 00:40 UTC.
  * Access to historical data via the Public API (Demo plan) is **restricted to the past 365 days** only. To access the complete range of historical data, please subscribe to one of our [paid plans](https://www.coingecko.com/en/api/pricing) to obtain a Pro-API key.
</Note>


## OpenAPI

````yaml api-reference/coingecko-demo.json get /coins/{id}/contract/{contract_address}/market_chart
openapi: 3.0.0
info:
  title: CoinGecko Demo API
  version: 3.0.0
servers:
  - url: https://api.coingecko.com/api/v3
security:
  - apiKeyAuth: []
  - apiKeyQueryParam: []
paths:
  /coins/{id}/contract/{contract_address}/market_chart:
    get:
      tags:
        - Contract
      summary: Coin Historical Chart Data by Token Address
      description: >-
        This endpoint allows you to **get the historical chart data including
        time in UNIX, price, market cap and 24hr volume based on asset platform
        and particular token contract address**
      operationId: contract-address-market-chart
      parameters:
        - name: id
          in: path
          description: |-
            asset platform ID 
             *refers to [`/asset_platforms`](/v3.0.1/reference/asset-platforms-list).
          required: true
          schema:
            type: string
            example: ethereum
            default: ethereum
        - name: contract_address
          in: path
          description: the contract address of token
          required: true
          schema:
            type: string
            example: '0xa0b86991c6218b36c1d19d4a2e9eb0ce3606eb48'
            default: '0xa0b86991c6218b36c1d19d4a2e9eb0ce3606eb48'
        - name: vs_currency
          in: query
          description: |-
            target currency of market data 
             *refers to [`/simple/supported_vs_currencies`](/v3.0.1/reference/simple-supported-currencies).
          required: true
          schema:
            type: string
            example: usd
            default: usd
        - name: days
          in: query
          description: |-
            data up to number of days ago 
             You may use any integer for number of days
          required: true
          schema:
            type: string
            default: '1'
          examples:
            value-1:
              value: '1'
            value-2:
              value: '365'
        - name: interval
          in: query
          description: data interval, leave empty for auto granularity
          required: false
          schema:
            type: string
            enum:
              - daily
              - hourly
        - name: precision
          in: query
          description: decimal place for currency price value
          required: false
          schema:
            type: string
            enum:
              - full
              - '0'
              - '1'
              - '2'
              - '3'
              - '4'
              - '5'
              - '6'
              - '7'
              - '8'
              - '9'
              - '10'
              - '11'
              - '12'
              - '13'
              - '14'
              - '15'
              - '16'
              - '17'
              - '18'
      responses:
        '200':
          description: >-
            Get historical market data include price, market cap, and 24hr
            volume
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CoinsMarketChart'
components:
  schemas:
    CoinsMarketChart:
      type: object
      properties:
        prices:
          type: array
          items:
            type: array
            items:
              type: number
        market_caps:
          type: array
          items:
            type: array
            items:
              type: number
        total_volumes:
          type: array
          items:
            type: array
            items:
              type: number
      example:
        prices:
          - - 1711843200000
            - 69702.3087473573
          - - 1711929600000
            - 71246.9514406015
          - - 1711983682000
            - 68887.7495158568
        market_caps:
          - - 1711843200000
            - 1370247487960.09
          - - 1711929600000
            - 1401370211582.37
          - - 1711983682000
            - 1355701979725.16
        total_volumes:
          - - 1711843200000
            - 16408802301.8374
          - - 1711929600000
            - 19723005998.215
          - - 1711983682000
            - 30137418199.6431
  securitySchemes:
    apiKeyAuth:
      type: apiKey
      in: header
      name: x-cg-demo-api-key
    apiKeyQueryParam:
      type: apiKey
      in: query
      name: x_cg_demo_api_key

````